Unit Bitmap;

Interface

function LoadBMP(AFileName:string):boolean;
function LoadBitmap:boolean; { COPY /B PROGRAM.EXE + BITMAP.BMP PROGRAM.EXE }

Const
 BMPSeg:word=$A000;

Implementation

uses Palette;

Type
 TBMPHeader=record

  bfType:array[1..2] of char;
  bfSize:LongInt;
  brReserved:LongInt;
  bgOffBits:LongInt;

  biSize:LongInt;
  biWidth:LongInt;
  biHeight:LongInt;
  biPlanes:word;
  biBitCount:word;
  biCompression:longint;
  biSizeImage:longint;
  biXPelsPerMeter:longint;
  biYPelsPerMeter:longint;
  biClrUsed:Longint;
  biClrImportant:longint;

 end;

 TBMPColors=array[0..255,0..3] of byte;
{ TRGBColors=array[0..255,0..2] of byte; }
 ArrayOfByte=Array[0..65532] of byte;

var
 ColorCount:word;
 BitCount:byte;
 BMPColors:TBMPColors;
 Datasize:longint;
 Data:^ArrayOfByte;

{ Colors:TRGBColors; }

 pixel:word;
 FixWidth:word;
  x,y:integer;

 remap:array[0..255] of byte;

procedure RemapColors;
 var
  r1,g1,b1,r2,g2,b2:longint;
  best,test:longint;
  c1,c2,c3:byte;
 begin

  for c1:=16 to colorcount-1 do begin
   remap[c1]:=c1;
   colors[c1,0]:=bmpcolors[c1,2] div 4;
   colors[c1,1]:=bmpcolors[c1,1] div 4;
   colors[c1,2]:=bmpcolors[c1,0] div 4;
  end;

  for c1:=0 to 15 do begin
   r1:=bmpcolors[c1,2] div 4;
   g1:=bmpcolors[c1,1] div 4;
   b1:=bmpcolors[c1,0] div 4;
   best:=64*64*3;
   c3:=c1;
   for c2:=0 to 255 do begin
    r2:=colors[c2,0]-r1;
    g2:=colors[c2,1]-g1;
    b2:=colors[c2,2]-b1;
    test:=r2*r2+g2*g2+b2*b2;
    if test<best then begin
     best:=test;
     c3:=c2;
    end;
   end;
   remap[c1]:=c3;
  end;

 end;

function GetPixel:byte;
 Var
  Result:byte;
 begin
  Result:=Data^[pixel]; { 256 colors }
  if BitCount=4 then begin { 16 colors }
   if odd(x) then begin
    Result:=Result shr 4;
   end else begin
    Result:=Result and $F;
    inc(pixel);
   end;
  end else
   inc(pixel);
  GetPixel:=remap[Result];
 end;

Procedure PutPixel(x,y,c:word); assembler;
 asm
  mov ax,y
  mov bx,320
  mul bx
  add ax,x
  mov es,BMPSeg
  mov di,ax
  mov ax,c
  stosb
 end;

function LoadFromFile(var f:file; Ofs:longint):boolean;
 var
  Header:TBMPHeader;
  i:integer;
 begin
  LoadFromFile:=False;

  Seek(f,Ofs);

  blockread(f,Header,SizeOf(Header));
  if IOResult<>0 then exit;

  if Header.bfType<>'BM' then exit;

  BitCount:=Header.biBitCount;

  ColorCount:=(Header.bgOffBits-SizeOf(Header)) div 4;
  if ColorCount>0 then BlockRead(f,BMPColors,4*ColorCount);

  DataSize:=Header.bfSize-Header.bgOffBits;
  GetMem(Data,DataSize);
  Seek(f,Header.bgOffBits+Ofs);
  BlockRead(f,Data^,DataSize);

  if ColorCount>0 then RemapColors;

  pixel:=0;
  FixWidth:=(Header.biWidth) mod 4;
  if FixWidth>0 then FixWidth:=4-FixWidth;
  if (FixWidth>0)and(Header.biBitCount=4)and(not odd(Header.biWidth)) then dec(FixWidth);
  For y:=Header.biHeight-1 downto 0 do begin
   for x:=0 to Header.biWidth-1 do PutPixel(x,y,GetPixel);
   inc(pixel,FixWidth);
  end;

  LoadFromFile:=True;
 end;

function LoadBMP(AFileName:string):boolean;
 var
  bmp:file;
 begin
  FileMode:=0;
  LoadBMP:=False;
  assign(bmp,AFileName);
  reset(bmp,1);
  if ioResult<>0 then exit;
  LoadBMP:=LoadFromFile(bmp,0);
  close(bmp);
 end;

function LoadBitmap:boolean;
 var
  exe:file;
  mzh:record
   SIGN :array[1..2] of char;
   PSize:word;
   Pages:word;
  end;
 begin
  FileMode:=0;
  LoadBitmap:=False;
  assign(exe,ParamStr(0)); { self ! }
  reset(exe,1);
  if IoResult<>0 then exit;
  BlockRead(exe,mzh,SizeOf(mzh));
  if mzh.SIGN='MZ' then
   LoadBitmap:=LoadFromFile(exe,512*(mzh.Pages-1)+mzh.PSize);
  close(exe);
 end;

end.